const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const outlet_revenues = sequelize.define(
    'outlet_revenues',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

revenue_date: {
        type: DataTypes.DATE,
      
      

      },

gross_revenue: {
        type: DataTypes.DECIMAL,
      
      

      },

net_revenue: {
        type: DataTypes.DECIMAL,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  outlet_revenues.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


























//end loop



    db.outlet_revenues.belongsTo(db.outlets, {
      as: 'outlet',
      foreignKey: {
        name: 'outletId',
      },
      constraints: false,
    });

    db.outlet_revenues.belongsTo(db.users, {
      as: 'input_by_user',
      foreignKey: {
        name: 'input_by_userId',
      },
      constraints: false,
    });

    db.outlet_revenues.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.outlet_revenues.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.outlet_revenues.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return outlet_revenues;
};


